<?
/*
Plugin Name: Flickrss
Version: 1.0
Plugin URI: http://blog.no-panic.at/projects/flickrss
Author: Florian Beer
Author URI: http://blog.no-panic.at
Description: Displays your Flickr account's latest comments in your blog's sidebar
*/

/*  Copyright 2006  Florian Beer  (email : flo@no-panic.at)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

function flickrss(){
	$options = get_settings('flickrss_options');
	if($options['flickrss_feedurl'] != ""){
		require_once('magpie/rss_fetch.inc');
		echo '<li><h2>'.$options['flickrss_title'].'</h2><ul>';
		$rss = fetch_rss($options['flickrss_feedurl']);
		$items = array_slice($rss->items,0,$options['flickrss_itemcount']);
		foreach($items as $item){
		if($options['flickrss_use_falbum']) {
			$href = explode("/", $item['link']);
			$href = $options['flickrss_photourl'].$href[count($href) - 2];				
		} else $href = $item['link'];
    	$title = str_replace("Comment about ",'',$item['title']);
		$title = iconv('ISO-8859-1','UTF-8',$title);
		$desc = $item['description'];
		$desc = substr($desc,0,strpos($desc,"<p><a href=\"http://www.flickr.com/photos/"));
		$replace = array("<p>","</p>","<br>","<br />"," has posted a comment");
		$desc = str_replace($replace,'',$desc);
		if(strlen($desc)>150) $desc = substr($desc,0,150)."...";
		$desc = iconv('ISO-8859-1','UTF-8',$desc);
    	echo '<li><a href="'.$href.'">'.$title.'</a> by '.$desc.'</li>';
		}
		echo "</ul></li>";
	}
}

function flickrss_options_page(){
	// do we have FAlbum?
	$falbum_options = get_settings('falbum_options');
	if(is_array($falbum_options)){
		$FAlbum = true;
		$flickrss_photourl = "http://".$_SERVER["HTTP_HOST"].$falbum_options['url_root']."show/recent/photo/";
	}
	$flckrss_photourl = ($FAlbum) ? $flickrss_photourl : '';

	// form sent, update DB
	if (isset($_POST['info_update'])) {
		$options = array('flickrss_feedurl'=>$_POST['flickrss_feedurl'], 'flickrss_title'=>$_POST['flickrss_title'], 'flickrss_photourl'=>$flickrss_photourl, 'flickrss_itemcount'=>$_POST['flickrss_itemcount'], 'flickrss_use_falbum'=>$_POST['flickrss_use_falbum']);
		update_option('flickrss_options', $options);
		echo '<div id="message" class="updated fade"><p><strong>Options Updated.</strong></p></div>';
	}

	
	// set options
	$options = get_settings('flickrss_options');
	if(!is_array($options)) {
		$options['flickrss_title'] = 'Latest Flickr comments:';
		$options['flickrss_feedurl'] = '';
		$options['flickrss_photourl'] = $flickrss_photourl;
		$options['flickrss_itemcount'] = '5';
		$options['flickrss_use_falbum'] = '0';
	}



	?>
	<?php if($FAlbum) { ?><div id="message" class="updated fade"><p><strong>FAlbum detected!</strong></p></div><?php } ?>
	<div class="wrap">
  		<form method="post">
    		<h2>Flickrss Options</h2>
    		<p>Here you can set all the options for Flickrss.</p>
			
			<h3>Headline</h3>
			<p>Set the headline: <input type="text" name="flickrss_title" value="<?php echo $options['flickrss_title']; ?>" size="30" /></p>

			<h3>Source Feed</h3>
			<p>Find your Comments Feed on the <a href="http://flickr.com/recent_activity.gne">Recent Activity on your photos</a> page on Flickr. Scroll all the way down untill you see the nice orange Feed icon. Copy the address and paste it into the input field.</p>
			<p>Feed URL: <input type="text" name="flickrss_feedurl" value="<?php echo $options['flickrss_feedurl']; ?>" size="70" /></p>

			<h3>Itemcount</h3>
			<p>How many comments do you want to show?</p> 
			<p>Show last <input type="text" name="flickrss_itemcount" value="<?php echo $options['flickrss_itemcount']; ?>" size="3" /> comments.</p>
     		
     		<?php if($FAlbum){ ?>
			<h3>Photo URL</h3>
			<p>Do you want the comments to link to your blog's image gallery (FAlbum) rather than back to Flickr?</p>
			<p><input type="radio" name="flickrss_use_falbum" value="1" <?php if($options['flickrss_use_falbum'] == '1' || ($options['flickrss_use_falbum'] == "" && $Falbum)) echo "checked"; ?> /> Yes!</p>
			<p><input type="radio" name="flickrss_use_falbum" value="0" <?php if($options['flickrss_use_falbum'] == '0' || ($options['flickrss_use_falbum'] == "" && !$Falbum)) echo "checked"; ?> /> No thanks!</p>
			<p><input type="hidden" name="flickrss_photourl" value="<?php echo $flickrss_photourl; ?>" /></p>
			<?php } ?>


			<div class="submit">
  				<input type="submit" name="info_update" value="Update options &raquo;" />
  			</div>
  		</form>
 	</div>
 	<?php
}

function flickrss_admin_menu() 
{
	add_options_page('Flickrss Options', 'Flickrss', '8', basename(__FILE__), 'flickrss_options_page');
}

add_action('admin_menu', 'flickrss_admin_menu');
?>